﻿Type=StaticCode
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
' Code module
' Subs In this code module will be accessible from all modules.

Sub Process_Globals
End Sub

Sub LogToFile(msg As String)
  Dim tw As TextWriter
  Dim os As OutputStream = File.OpenOutput(File.DirDefaultExternal, "LogFile.txt", True)
  
  tw.Initialize(os)
  tw.WriteLine(msg)
  tw.Flush
  tw.Close
End Sub

Sub Sprintf(fmt As String, arg() As Object) As String
  Dim ai, fi, i As Int
  Dim exp, wid As Int
  Dim stmp, ptmp, sres, c, T As String
  Dim bdone As Boolean
  
  ai = 0
  fi = 0
  stmp = ""
  sres = ""
  
  Do While (fi < fmt.Length)
    c = fmt.CharAt(fi)
    fi = fi + 1
	
    If (c = "%") Then
	  stmp = ""
	  ptmp = ""
	  bdone = False
	  
      Do While ((fi < fmt.Length) AND (bdone = False))
        c = fmt.CharAt(fi)
		fi = fi + 1
		
	    If (c = "%") Then
          sres = sres & c
		  bdone = True
	    Else If ((IsNumber(c) = True) OR (c = ".")) Then
		  ptmp = ptmp & c
		  bdone = False
		Else If (c = "s") Then
		  stmp = arg(ai)
		  ai = ai + 1
		  sres = sres & stmp
		  bdone = True
		Else If (c = "d") Then
		  If (ptmp.Length > 0) Then
		    T = " "
			If (ptmp.CharAt(0) = "0") Then
			  T = "0"
			  ptmp = ptmp.SubString(1)
			End If
		  End If
		  
		  If (ptmp.Length > 0) Then wid = ptmp Else wid = 0
		  
		  stmp = arg(ai)
		  
		  Do While (stmp.Length < wid)
		    stmp = T & stmp
		  Loop
		  
		  ai = ai + 1
		  sres = sres & stmp
		  bdone = True
		Else If (c = "f") Then
		  If (ptmp.Length > 0) Then
		    i = ptmp.IndexOf(".")
		    If (i >= 0) Then
			  wid = ptmp.SubString2(0, i)
			  exp = ptmp.SubString(i+1)
			Else
			  wid = ptmp
			  exp = 0
			End If
		    
			stmp = NumberFormat(arg(ai), wid, exp)
		  Else
		    stmp = arg(ai)
		  End If

		  ai = ai + 1
		  sres = sres & stmp
		  bdone = True
		Else
		  ai = ai + 1
		End If
		
	  Loop
	Else
	  sres = sres & c
	End If
  Loop
  
  Return(sres)
End Sub

Sub FmtMSecToHMS(tim As Double) As String
  Dim lt = tim / 1000
  
  Dim H As Double = Floor(lt / 3600)
  lt = lt - (H * 3600)
  
  Dim m As Double = Floor(lt / 60)
  lt = lt - (m * 60)
  
  Dim S As Double = Floor(lt)
  
  Dim str(3) As String
  
  str(0) = NumberFormat(H, 1, 0)
  str(1) = NumberFormat(m, 1, 0)
  str(2) = NumberFormat(S, 1, 0)
  
  If (H > 0) Then
    Return(str(0) & ":" & str(1) & ":" & str(2) & " hr")
  Else If (m > 0) Then
    Return(str(1) & ":" & str(2) & " min")
  Else
    Return(str(2) & " sec")
  End If
End Sub

' HH - hours, always 2 digit, 24 hour
' H - hours, possibly 1 digit, 24 hour
' hh - hours, always 2 digit, 12 hour
' h - hours, possibly 1 digit, 12 hour
' mm - minutes, always 2 digit
' m - minutes, possibly 1 digit
' ss - seconds, always 2 digits
' yyyy - full year value (4 digits)
' yy - truncated year (2 digits)
' MMM - month three letter abrev.
' MM - month, always 2 digits
' M - month, possibly 1 digit
' dd - day of month, always 2 digits
' d - day of month, possibly 1 digit

Sub FormatDateTime(fmt As String, dt As Long) As String
  Dim i, j As Int
  Dim S, T, so, MonthNames(12) As String
  
  S = fmt
  so = ""
  MonthNames = Array As String("Jan", "Feb", "Mar", "Apr", _
    "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec")
  
  Do While (S.Length > 0)
    If (S.StartsWith("HH")) Then
	  T = NumberFormat2(DateTime.GetHour(dt), 2, 0, 0, False)
	  j = 2
	Else If (S.StartsWith("H")) Then
	  T = NumberFormat2(DateTime.GetHour(dt), 1, 0, 0, False)
	  j = 1
	Else If (S.StartsWith("hh")) Then
	  i = DateTime.GetHour(dt)
	  If (i > 12) Then i = i - 12
	  T = NumberFormat2(i, 2, 0, 0, False)
	  j = 2
	Else If (S.StartsWith("h")) Then
	  i = DateTime.GetHour(dt)
	  If (i > 12) Then i = i - 12
	  T = NumberFormat2(i, 1, 0, 0, False)
	  j = 1
	Else If (S.StartsWith("mm")) Then
	  T = NumberFormat2(DateTime.GetMinute(dt), 2, 0, 0, False)
	  j = 2
	Else If (S.StartsWith("m")) Then
	  T = NumberFormat2(DateTime.GetMinute(dt), 1, 0, 0, False)
	  j = 1
	Else If (S.StartsWith("ss")) Then
	  T = NumberFormat2(DateTime.GetSecond(dt), 2, 0, 0, False)
	  j = 2
	Else If (S.StartsWith("yyyy")) Then
	  T = NumberFormat2(DateTime.GetYear(dt), 1, 0, 0, False)
	  j = 4
	Else If (S.StartsWith("yy")) Then
	  T = NumberFormat2(DateTime.GetYear(dt), 1, 0, 0, False)
	  i = Max(T.Length - 2, 0)
	  T = T.SubString(i)
	  j = 2
	Else If (S.StartsWith("MMM")) Then
	  i = DateTime.GetMonth(dt)
	  T = MonthNames(i - 1)
	  j = 3
	Else If (S.StartsWith("MM")) Then
	  T = NumberFormat2(DateTime.GetMonth(dt), 2, 0, 0, False)
	  j = 2
	Else If (S.StartsWith("M")) Then
	  T = NumberFormat2(DateTime.GetMonth(dt), 1, 0, 0, False)
	  j = 1
	Else If (S.StartsWith("dd")) Then
	  T = NumberFormat2(DateTime.GetDayOfMonth(dt), 2, 0, 0, False)
	  j = 2
	Else If (S.StartsWith("d")) Then
	  T = NumberFormat2(DateTime.GetDayOfMonth(dt), 1, 0, 0, False)
	  j = 1
	Else
	  T = S.SubString2(0, 1)
	  j = 1
	End If
	
	so = so & T
	S = S.SubString(j)
  Loop
  
  Return(so)
End Sub
