﻿Type=Service
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
  #StartAtBoot: False
#End Region

Sub Process_Globals
  Type Message (Address As String, Body As String)
End Sub

Sub Service_Create
End Sub

Sub Service_Start (StartingIntent As Intent)
  Utl.LogToFile("Got Intent")

  If (StartingIntent.Action = "android.provider.Telephony.SMS_RECEIVED") Then
    Dim messages() As Message
	 
    messages = ParseSmsIntent(StartingIntent)

    Utl.LogToFile("SMS_RECEIVED")

	For i = 0 To messages.Length - 1
      Utl.LogToFile(Utl.Sprintf("  %s", Array As String(messages(i))))
    Next

  Else
    Utl.LogToFile(Utl.Sprintf("%s: Got Intent: %s", _
	  Array As String(Utl.FormatDateTime("MM/dd hh:mm", DateTime.Now), StartingIntent.GetData)))
	
    Dim noti As Notification 'shows in the notification window

    noti.Initialize

    noti.Icon = "icon"
    'noti.Notify(1)
    noti.Sound = False
    noti.Vibrate = False
    noti.Light = False

    noti.SetInfo("SMS Detect", "Running", Main)

    Service.StartForeground(1, noti)
  End If
End Sub

Sub Service_Destroy
  Service.StopForeground(1)
End Sub

'Parses an SMS intent and returns an array of messages
Sub ParseSmsIntent (In As Intent) As Message()
   Dim messages() As Message
   
   If (In.HasExtra("pdus") = False) Then Return messages
   
   Dim pdus() As Object
   Dim r As Reflector
   
   pdus = In.GetExtra("pdus")
   
   If (pdus.Length > 0) Then
      Dim messages(pdus.Length) As Message
	  
      For i = 0 To pdus.Length - 1
         r.Target = r.RunStaticMethod("android.telephony.SmsMessage", "createFromPdu", _
            Array As Object(pdus(i)), Array As String("[B"))
			
         messages(i).Body = r.RunMethod("getMessageBody")
         messages(i).Address = r.RunMethod("getOriginatingAddress")
      Next
   End If
   
   Return (messages)
End Sub
 
